## qtrvsim 0.9.8

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
cmake_policy(VERSION 3.10)

project(QtRVSim
        LANGUAGES C CXX
        VERSION 0.9.8
        DESCRIPTION "RISC-V CPU simulator for education purposes")

set(KAREL_KOCI "Karel Koci <cynerd@email.cz>")
set(PAVEL_PISA "Pavel Pisa <pisa@cmp.felk.cvut.cz>")
set(JAKUB_DUPAK "Jakub Dupak <dev@jakubdupak.com>")
set(MAX_HOLLMANN "Max Hollmann <hollmmax@fel.cvut.cz>")

set(PROJECT_HOMEPAGE_URL "https://github.com/cvut/qtrvsim")
set(GENERIC_NAME "RISC-V CPU simulator")
set(LICENCE "GPL-3.0-or-later")
set(LONG_DESCRIPTION
        "RISC-V CPU simulator for education purposes with pipeline and cache visualization.")
string(TIMESTAMP YEAR "%Y")

include(cmake/CopyrightTools.cmake)


copyright(
        "Copyright (c) 2017-2019 ${KAREL_KOCI}"
        "Copyright (c) 2019-${YEAR} ${PAVEL_PISA}"
        "Copyright (c) 2020-${YEAR} ${JAKUB_DUPAK}"
        "Copyright (c) 2020-2021 ${MAX_HOLLMANN}")

include(cmake/GPL-3.0-or-later.cmake)

# =============================================================================
# Configurable options
# =============================================================================

set(DEV_MODE false CACHE BOOL "Enable developer options in this CMake, like packaging.\
    They should be ignored, when user just wants to build this project.")
set(FORCE_ELFLIB_STATIC false CACHE BOOL
        "Use included statically linked libelf even if system one is available.")
set(SANITIZERS "address,undefined" CACHE STRING
        "Runtime sanitizers to use in debug builds.
    Column separated subset of {address, memory, undefined, thread} or none.
    Memory and address cannot be used at the same time.")
set(EXECUTABLE_OUTPUT_PATH "${CMAKE_BINARY_DIR}/target"
        CACHE STRING "Absolute path to place executables to.")
set(PACKAGE_OUTPUT_PATH "${EXECUTABLE_OUTPUT_PATH}/pkg"
        CACHE STRING "Absolute path to place generated package files.")
set(FORCE_COLORED_OUTPUT false CACHE BOOL "Always produce ANSI-colored output (GNU/Clang only).")
set(USE_ALTERNATE_LINKER "" CACHE STRING "Use alternate linker. Leave empty for system default; alternatives are 'gold', 'lld', 'bfd', 'mold'")
set(QT_VERSION_MAJOR "auto" CACHE STRING "Qt major version to use. 5|6|auto")

# =============================================================================
# Generated variables
# =============================================================================

if (NOT "${QT_VERSION_MAJOR}" MATCHES "5|6|auto")
    message(FATAL_ERROR "Invalid value for QT_VERSION_MAJOR: ${QT_VERSION_MAJOR} (expected 5, 6 or auto)")
endif ()

if (${CMAKE_SYSTEM_NAME} MATCHES "Emscripten")
    set(WASM true)
else ()
    set(WASM false)
endif ()
set(CXX_TEST_PATH ${EXECUTABLE_OUTPUT_PATH})
set(C_TEST_PATH ${EXECUTABLE_OUTPUT_PATH})


macro(set_alternate_linker linker)
    find_program(LINKER_EXECUTABLE ld.${USE_ALTERNATE_LINKER} ${USE_ALTERNATE_LINKER})
    if (LINKER_EXECUTABLE)
        if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" AND "${CMAKE_CXX_COMPILER_VERSION}" VERSION_LESS 12.0.0)
            add_link_options("-ld-path=${USE_ALTERNATE_LINKER}")
        else ()
            add_link_options("-fuse-ld=${USE_ALTERNATE_LINKER}")
        endif ()
    else ()
        set(USE_ALTERNATE_LINKER "" CACHE STRING "Use alternate linker" FORCE)
    endif ()
endmacro()
if (NOT "${USE_ALTERNATE_LINKER}" STREQUAL "")
    set_alternate_linker(${USE_ALTERNATE_LINKER})
endif ()

# I don't want to relly on the assumption, that this file is invoked as root
# project. Therefore I propagate the information to all subprojects
# MAIN_PROJECT_*. Lowercase and uppercase are used for executable names and
# C defines, respectively.
set(MAIN_PROJECT_NAME "${PROJECT_NAME}")
set(MAIN_PROJECT_VERSION "${PROJECT_VERSION}")
set(MAIN_PROJECT_APPID "cz.cvut.edu.comparch.qtrvsim")
set(MAIN_PROJECT_ORGANIZATION "FEE CTU")
set(MAIN_PROJECT_HOMEPAGE_URL "${PROJECT_HOMEPAGE_URL}")
string(TOLOWER "${PROJECT_NAME}" MAIN_PROJECT_NAME_LOWER)
string(TOUPPER "${PROJECT_NAME}" MAIN_PROJECT_NAME_UPPER)

# =============================================================================
# CMake config and tools
# =============================================================================

list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

if (CMAKE_VERSION VERSION_LESS "3.7.0")
    set(CMAKE_INCLUDE_CURRENT_DIR ON)
endif ()

include(cmake/BuildType.cmake)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# =============================================================================
# Build options
# - common to all subdirs
# =============================================================================

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# MSVC is not supported, Clang+MSVC currently does not seem to support sanitizers in with debug CRT,
#  MinGW does not support sanitizers at all; all together, just skip sanitizers on Windows and re-investigate
#  in a year or two whether Clang sanitizer support has improved
if (NOT "${SANITIZERS}" MATCHES "none" AND NOT "${WASM}" AND NOT "${WIN32}")
    set(CMAKE_C_FLAGS_DEBUG
            "${CMAKE_C_FLAGS_DEBUG} -fno-omit-frame-pointer -fsanitize=${SANITIZERS} -g -g3 -ggdb")
    set(CMAKE_CXX_FLAGS_DEBUG
            "${CMAKE_CXX_FLAGS_DEBUG} -fno-omit-frame-pointer -fsanitize=${SANITIZERS} -g -g3 -ggdb")
    set(CMAKE_LINKER_FLAGS_DEBUG
            "${CMAKE_LINKER_FLAGS_DEBUG} -fno-omit-frame-pointer -fsanitize=${SANITIZERS}")
endif ()

if (NOT "${BUILD_DEBUG}")
    message(STATUS "Debug prints globally suppressed.")
    add_definitions(-DQT_NO_DEBUG_OUTPUT=1)
endif ()

include_directories("src" "src/machine")


if (${FORCE_COLORED_OUTPUT})
    if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
        add_compile_options(-fdiagnostics-color=always)
    elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
        add_compile_options(-fcolor-diagnostics)
    endif ()
endif ()

## ============================================================================
## Warning level
## ============================================================================

if (WIN32)
    # otherwise CRT complains that `strerror` is deprecated
    add_compile_definitions(_CRT_SECURE_NO_WARNINGS)
endif ()

if (MSVC)
    add_compile_options(/W4 /WX)
else ()
    add_compile_options(-Wall -Wextra -Werror=switch)
    if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
        # This is currently a wont-fix and it will be OK in cpp20.
        add_compile_options(-Wno-c99-designator)
    endif ()
endif ()

# =============================================================================
# Dependencies
# =============================================================================

if ("${WASM}")
    message(STATUS "WASM build detected")

    message(STATUS "Enabled WASM exception handling")
    add_compile_options("-fexceptions")
    # Extra options for WASM linking
    add_link_options("-fexceptions")
    add_link_options("-flto")
    # Activate Embind C/C++ bindings
    # https://emscripten.org/docs/porting/connecting_cpp_and_javascript/embind.html
    add_link_options("--bind")
    # Enable C++ exception catching
    # https://emscripten.org/docs/optimizing/Optimizing-Code.html#c-exceptions
    add_link_options("SHELL:-s DISABLE_EXCEPTION_CATCHING=0")
    # Enable Fetch API
    # https://emscripten.org/docs/api_reference/fetch.html
    add_link_options("SHELL:-s FETCH=1")
    add_link_options("SHELL:-s WASM=1")
    # Emulate missing OpenGL ES2/ES3 features
    # https://emscripten.org/docs/porting/multimedia_and_graphics/OpenGL-support.html#opengl-es-2-0-3-0-emulation
    add_link_options("SHELL:-s FULL_ES2=1")
    add_link_options("SHELL:-s FULL_ES3=1")
    # Activate WebGL 2 (in addition to WebGL 1)
    # https://emscripten.org/docs/porting/multimedia_and_graphics/OpenGL-support.html#webgl-friendly-subset-of-opengl-es-2-0-3-0
    add_link_options("SHELL:-s USE_WEBGL2=1")
    # Run static dtors at teardown
    # https://emscripten.org/docs/getting_started/FAQ.html#what-does-exiting-the-runtime-mean-why-don-t-atexit-s-run
    add_link_options("SHELL:-s ALLOW_MEMORY_GROWTH=1")
    # Export UTF16ToString,stringToUTF16
    # Required by https://codereview.qt-project.org/c/qt/qtbase/+/286997 (since Qt 5.14)
    add_link_options("SHELL:-s EXTRA_EXPORTED_RUNTIME_METHODS=[\"UTF16ToString\",\"stringToUTF16\"]")
    # Enable demangling of C++ stack traces
    # https://emscripten.org/docs/porting/Debugging.html
    add_link_options("SHELL:-s DEMANGLE_SUPPORT=1")
    # Run static dtors at teardown
    # https://emscripten.org/docs/getting_started/FAQ.html#what-does-exiting-the-runtime-mean-why-don-t-atexit-s-run
    add_link_options("SHELL:-s EXIT_RUNTIME=1")

    # Debug build
    if ("${BUILD_DEBUG}")
        message(STATUS "Enabled WASM debug")
        add_link_options("SHELL:-s ERROR_ON_WASM_CHANGES_AFTER_LINK")
        add_link_options("SHELL:-s WASM_BIGINT")
        add_link_options("-O1")
    endif ()

    add_definitions(-DQT_NO_DEBUG_OUTPUT=1)
    message(STATUS "Debug output disabled")
else ()
    # Not available for WASM
    enable_testing()

    if (NOT "${FORCE_ELFLIB_STATIC}")
        find_package(LibElf)
        if ("${LibElf_FOUND}")
            include(CheckSymbolExists)
            check_symbol_exists(EM_RISCV "gelf.h" LIBELF_HAS_RISCV)
            if ("${LIBELF_HAS_RISCV}")
                # Turn non-cmake library into a cmake target
                add_library(libelf INTERFACE)
                target_link_libraries(libelf INTERFACE ${LIBELF_LIBRARY})
                target_include_directories(libelf INTERFACE ${LIBELF_INCLUDE_DIR})
                message(STATUS "Using system libelf")
            else ()
                message(STATUS "System libelf does not support RISC-V")
                set(LibElf_FOUND FALSE) # Force fallback
            endif ()
        endif ()
    endif ()
endif ()

if ("${WASM}" OR "${FORCE_ELFLIB_STATIC}" OR NOT "${LibElf_FOUND}")
    message(STATUS "Using local libelf fallback.")
    add_subdirectory("external/libelf")
endif ()

# Detect Qt used qt version
# Based on article https://www.steinzone.de/wordpress/how-to-support-both-qt5-and-qt6-using-cmake/
# Cannot use version-less approach due to Qt 5.9.5 support constraint.

if ("${QT_VERSION_MAJOR}" STREQUAL "auto")
    find_package(QT NAMES Qt5 Qt6 COMPONENTS Core REQUIRED)
endif ()

# Normally, we would use variable Qt5 or Qt6 to reference the Qt library. Here we do that through
# this variable based on detected version major of Qt.
set(QtLib "Qt${QT_VERSION_MAJOR}")
find_package(${QtLib}
        REQUIRED COMPONENTS Core Widgets Gui Test
        OPTIONAL_COMPONENTS PrintSupport)

message(STATUS "${QtLib} version: ${${QtLib}Core_VERSION}")
message(STATUS "${QtLib} print support: ${${QtLib}PrintSupport_FOUND}")

if ("${WASM}")
    string(TIMESTAMP DATE "%Y%m%d")
    file(READ "${${QtLib}Core_DIR}/../../../plugins/platforms/qtloader.js" QTLOADER)
    string(REPLACE "applicationName + \".js\"" "applicationName + \".js?v=${DATE}\"" QTLOADER "${QTLOADER}")
    string(REPLACE "applicationName + \".wasm\"" "applicationName + \".wasm?v=${DATE}\"" QTLOADER "${QTLOADER}")
    file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/target/qtloader.js" "${QTLOADER}")
endif ()


# Qt 5.9.5 is the oldest supported
add_definitions(-DQT_DISABLE_DEPRECATED_BEFORE=0x050905)

add_subdirectory("external/svgscene")

# =============================================================================
# Sources
# =============================================================================

add_subdirectory("src/common")
add_subdirectory("src/machine")
add_subdirectory("src/assembler")
add_subdirectory("src/os_emulation")
add_subdirectory("src/gui")
if (NOT "${WASM}")
    add_subdirectory("src/cli")
    add_custom_target(all_unit_tests
            DEPENDS common_unit_tests machine_unit_tests)
endif ()

# =============================================================================
# Installation

=== Makefile ===
include .dev-config.mk

.dev-config.mk:
	[ ! -f .dev-config.mk ] && cp .dev-config.mk.default .dev-config.mk

release:
	mkdir -p build/Release
	cd build/Release && cmake -DCMAKE_BUILD_TYPE=Release ../..
	cd build/Release && cmake --build .

debug:
	mkdir -p build/Debug
	cd build/Debug && cmake -DCMAKE_BUILD_TYPE=Debug ../..
	cd build/Debug && cmake --build .

########################################################################################################################
# WASM
########################################################################################################################

wasm:
	bash extras/building/build-wasm.sh $(EMSCRIPTEN_VERSION) $(QT_WASM_PATH) $(EMSDK_PATH)

wasm-clean:
	rm -rf $(WASM_BUILD_DIR)

wasm-clean-deep: wasm-clean
	rm -rf $(EMSDK_PATH)/upstream/cache/*
	rm -rf $(EMSDK_PATH)/upstream/emscripten/cache/*

wasm-serve:
	cp data/wasm/* $(WASM_BUILD_DIR)/target
	# Server is necessary due to CORS
	cd $(WASM_BUILD_DIR)/target/ && python -m http.server
	open localhost:8000

wasm-install-qt:
	python -m aqt install $(QT_WASM_VERSION) linux desktop wasm_32 --outputdir $(QT_INSTALL_DIR)

.PHONY: release debug wasm wasm-clean wasm-clean-deep wasm-serve wasm-install-qt

=== external/libelf/CMakeLists.txt ===
project(libelf)

set(libelf_SOURCES
        32.fsize.c
        32.getehdr.c
        32.getphdr.c
        32.getshdr.c
        32.newehdr.c
        32.newphdr.c
        32.xlatetof.c
        64.xlatetof.c
        assert.c
        begin.c
        checksum.c
        cntl.c
        cook.c
        data.c
        end.c
        errmsg.c
        errno.c
        fill.c
        flag.c
        gelfehdr.c
        gelfphdr.c
        gelfshdr.c
        gelftrans.c
        getarhdr.c
        getaroff.c
        getarsym.c
        getbase.c
        getdata.c
        getident.c
        getscn.c
        hash.c
        input.c
        kind.c
        ndxscn.c
        newdata.c
        newscn.c
        next.c
        nextscn.c
        nlist.c
        opt.delscn.c
        rand.c
        rawdata.c
        rawfile.c
        strptr.c
        swap64.c
        update.c
        verdef_32_tof.c
        verdef_32_tom.c
        verdef_64_tof.c
        verdef_64_tom.c
        version.c
        x.elfext.c
        x.movscn.c
        x.remscn.c
        )

set(libelf_HEADERS
        config.h
        byteswap.h
        elf_repl.h
        errors.h
        ext_types.h
        gelf.h
        libelf.h
        nlist.h
        private.h
        verdef.h
        verneed.h
        sys_elf.h
        )

add_library(libelf STATIC
        ${libelf_HEADERS}
        ${libelf_SOURCES})
# This is 3rd party code, I do not intend to fix it.
target_compile_options(libelf PRIVATE -w)
target_include_directories(libelf PUBLIC .)
target_compile_definitions(libelf PUBLIC __LIBELF_INTERNAL__)
target_compile_definitions(libelf PUBLIC HAVE_CONFIG_H=1)
set_target_properties(libelf PROPERTIES LINKER_LANGUAGE C)

=== external/svgscene/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(svgscene)


find_package(QT NAMES Qt6 Qt5 COMPONENTS Core REQUIRED)
# Normally, we would use variable Qt5 or Qt6 to reference the Qt library. Here we do that through
# this variable based on detected version major of Qt.
set(QtLib "Qt${QT_VERSION_MAJOR}")
find_package(${QtLib}
		REQUIRED COMPONENTS Core Widgets Gui)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

add_library(svgscene STATIC
		src/svgscene/components/groupitem.cpp
		src/svgscene/components/groupitem.h
		src/svgscene/components/hyperlinkitem.cpp
		src/svgscene/components/hyperlinkitem.h
		src/svgscene/components/simpletextitem.cpp
		src/svgscene/components/simpletextitem.h
		src/svgscene/graphicsview/svggraphicsview.cpp
		src/svgscene/graphicsview/svggraphicsview.h
		src/svgscene/svgdocument.cpp
		src/svgscene/svgdocument.h
		src/svgscene/svggraphicsscene.cpp
		src/svgscene/svggraphicsscene.h
		src/svgscene/svghandler.cpp
		src/svgscene/svghandler.h
		src/svgscene/svgmetadata.cpp
		src/svgscene/svgmetadata.h
		src/svgscene/svgspec.h
		src/svgscene/polyfills/qt5/qwheelevent.h
		src/svgscene/polyfills/qt5/qstringview.h
		src/svgscene/utils/logging.h
		src/svgscene/utils/memory_ownership.h
		)
target_link_libraries(svgscene
		PRIVATE ${QtLib}::Core ${QtLib}::Gui ${QtLib}::Widgets)
target_include_directories(svgscene PUBLIC src PRIVATE src/svgscene)

add_executable(svgscene-example EXCLUDE_FROM_ALL
		src/example/main.cpp
		src/example/mainwindow.cpp
		src/example/mainwindow.h
		src/example/mainwindow.ui
		)
target_link_libraries(svgscene-example
		PRIVATE ${QtLib}::Core ${QtLib}::Gui ${QtLib}::Widgets svgscene)

=== src/assembler/CMakeLists.txt ===
project(assembler
        DESCRIPTION "Simple assembler library to use in the UI.")

set(CMAKE_AUTOMOC ON)

set(assembler_SOURCES
        fixmatheval.cpp
        simpleasm.cpp
        )
set(assembler_HEADERS
        fixmatheval.h
        messagetype.h
        simpleasm.h
        )

add_library(assembler STATIC
        ${assembler_SOURCES}
        ${assembler_HEADERS})
target_link_libraries(assembler
		PRIVATE ${QtLib}::Core)

=== src/cli/CMakeLists.txt ===
project(cli
        LANGUAGES C CXX
        VERSION ${MAIN_PROJECT_VERSION}
        DESCRIPTION "Simulator command-line UI.")

set(CMAKE_AUTOMOC ON)

set(cli_SOURCES
        chariohandler.cpp
        main.cpp
        msgreport.cpp
        reporter.cpp
        tracer.cpp
)
set(cli_HEADERS
        chariohandler.h
        msgreport.h
        reporter.h
        tracer.h
)

add_executable(cli
        ${cli_SOURCES}
        ${cli_HEADERS})
target_link_libraries(cli
        PRIVATE ${QtLib}::Core machine os_emulation assembler)
target_compile_definitions(cli
        PRIVATE
        APP_ORGANIZATION=\"${MAIN_PROJECT_ORGANIZATION}\"
        APP_ORGANIZATION_DOMAIN=\"${MAIN_PROJECT_HOMEPAGE_URL}\"
        APP_NAME=\"${MAIN_PROJECT_NAME}\"
        APP_VERSION=\"${PROJECT_VERSION}\"
        ENV_CONFIG_FILE_NAME=\"${MAIN_PROJECT_NAME_UPPER}_CONFIG_FILE\")
set_target_properties(cli PROPERTIES
        OUTPUT_NAME "${MAIN_PROJECT_NAME_LOWER}_${PROJECT_NAME}")

# =============================================================================
# Installation
# =============================================================================

# Prior to CMake version 3.13, installation must be performed in the subdirectory,
# there the target was created. Therefore executable installation is to be found
# in corresponding CMakeLists.txt.

install(TARGETS cli
        RUNTIME DESTINATION bin)

include(../../cmake/TestingTools.cmake)

enable_testing()

add_cli_test(
        NAME stalls
        ARGS
        --asm "${CMAKE_SOURCE_DIR}/tests/cli/stalls/program.S"
        --dump-registers
        EXPECTED_OUTPUT "tests/cli/stalls/stdout.txt"
)

add_cli_test(
        NAME asm_error
        ARGS
        --asm "${CMAKE_SOURCE_DIR}/tests/cli/asm-error/program.S"
)
set_tests_properties(cli_asm_error PROPERTIES WILL_FAIL TRUE)

add_cli_test(
        NAME modifiers
        ARGS
        --asm "${CMAKE_SOURCE_DIR}/tests/cli/modifiers/program.S"
        EXPECTED_OUTPUT "tests/cli/modifiers/stdout.txt"
)

add_cli_test(
        NAME modifiers-pcrel
        ARGS
        --asm "${CMAKE_SOURCE_DIR}/tests/cli/modifiers-pcrel/program.S"
        EXPECTED_OUTPUT "tests/cli/modifiers-pcrel/stdout.txt"
)

=== src/common/CMakeLists.txt ===
project(common
		DESCRIPTION "Utils shared between multiple subprojects.")

add_subdirectory(polyfills)

set(common_HEADERS
		endian.h
		string_utils.h
		logging.h
		logging_format_colors.h
		containers/cvector.h
		math/bit_ops.h
		memory_ownership.h
		type_utils/lens.h
		)

# =============================================================================
# Target for usage of this header library
# - this is header only library and it is implicitly available in the whole
#   project
# =============================================================================

# =============================================================================
# Tests
# - It is highly recommended to run these tests anytime you use a different
#   compiler or platform as this code is platform/compiler specific.
# =============================================================================

enable_testing()
set(CMAKE_AUTOMOC ON)

# Put tests here...

add_custom_target(common_unit_tests
		DEPENDS mulh64_test)

=== src/gui/CMakeLists.txt ===
project(gui
        LANGUAGES C CXX
        VERSION ${MAIN_PROJECT_VERSION}
        DESCRIPTION "Graphical UI for the simulator")

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

set(gui_SOURCES
        dialogs/about/aboutdialog.cpp
        windows/cache/cachedock.cpp
        windows/cache/cacheview.cpp
        windows/csr/csrdock.cpp
        windows/coreview/scene.cpp
        extprocess.cpp
        fontsize.cpp
        dialogs/gotosymbol/gotosymboldialog.cpp
        graphicsview.cpp
        windows/memory/memorydock.cpp
        windows/memory/memorymodel.cpp
        windows/memory/memorytableview.cpp
        windows/messages/messagesdock.cpp
        windows/messages/messagesmodel.cpp
        windows/messages/messagesview.cpp
        dialogs/new/newdialog.cpp
        ui/hexlineedit.cpp
        windows/editor/highlighterasm.cpp
        windows/editor/highlighterc.cpp
        windows/editor/linenumberarea.cpp
        windows/editor/editordock.cpp
        windows/editor/editortab.cpp
        hinttabledelegate.cpp
        windows/lcd/lcddisplaydock.cpp
        windows/lcd/lcddisplayview.cpp
        main.cpp
        mainwindow/mainwindow.cpp
        windows/peripherals/peripheralsdock.cpp
        windows/peripherals/peripheralsview.cpp
        windows/program/programdock.cpp
        windows/program/programmodel.cpp
        windows/program/programtableview.cpp
        windows/registers/registersdock.cpp
        dialogs/savechanged/savechangeddialog.cpp
        windows/editor/srceditor.cpp
        statictable.cpp
        windows/terminal/terminaldock.cpp
        textsignalaction.cpp
        windows/coreview/components/value_handlers.cpp
        windows/coreview/components/cache.cpp
        widgets/hidingtabwidget.cpp
        windows/predictor/predictor_btb_dock.cpp
        windows/predictor/predictor_bht_dock.cpp
        windows/predictor/predictor_info_dock.cpp
        )
set(gui_HEADERS
        dialogs/about/aboutdialog.h
        windows/cache/cachedock.h
        windows/cache/cacheview.h
        windows/csr/csrdock.h
        windows/coreview/scene.h
        extprocess.h
        fontsize.h
        dialogs/gotosymbol/gotosymboldialog.h
        graphicsview.h
        windows/memory/memorydock.h
        windows/memory/memorymodel.h
        windows/memory/memorytableview.h
        windows/messages/messagesdock.h
        windows/messages/messagesmodel.h
        windows/messages/messagesview.h
        dialogs/new/newdialog.h
        ui/hexlineedit.h
        windows/editor/highlighterasm.h
        windows/editor/highlighterc.h
        windows/editor/linenumberarea.h
        windows/editor/editordock.h
        hinttabledelegate.h
        windows/lcd/lcddisplaydock.h
        windows/lcd/lcddisplayview.h
        mainwindow/mainwindow.h
        windows/peripherals/peripheralsdock.h
        windows/peripherals/peripheralsview.h
        windows/program/programdock.h
        windows/program/programmodel.h
        windows/program/programtableview.h
        windows/registers/registersdock.h
        dialogs/savechanged/savechangeddialog.h
        windows/editor/srceditor.h
        statictable.h
        windows/terminal/terminaldock.h
        textsignalaction.h
        windows/coreview/components/value_handlers.h
        windows/coreview/data.h
        windows/coreview/components/cache.h
        helper/async_modal.h
        widgets/hidingtabwidget.h
        windows/predictor/predictor_btb_dock.h
        windows/predictor/predictor_bht_dock.h
        windows/predictor/predictor_info_dock.h
        )
set(gui_UI
        dialogs/gotosymbol/gotosymboldialog.ui
        dialogs/new/NewDialog.ui
        windows/peripherals/peripheralsview.ui
        mainwindow/MainWindow.ui
        dialogs/new/NewDialogCache.ui
        )
set(gui_RESOURCES
        resources/icons/icons.qrc
        resources/samples/samples.qrc
        windows/coreview/schemas/schemas.qrc
        )


if ("${WASM}")
    message(STATUS "gui :: Including WASM only files.")
    list(APPEND gui_SOURCES qhtml5file_html5.cpp)
    list(APPEND gui_HEADERS qhtml5file.h)
endif ()

# MACOS
set(ICON_NAME gui)
set(ICON_PATH ${CMAKE_SOURCE_DIR}/data/icons/macos/${ICON_NAME}.icns)
# END MACOS

add_executable(gui
        ${ICON_PATH}
        ${gui_SOURCES}
        ${gui_HEADERS}
        ${gui_UI}
        ${gui_RESOURCES})
target_include_directories(gui PUBLIC . windows/coreview)
target_link_libraries(gui
        PRIVATE ${QtLib}::Core ${QtLib}::Widgets ${QtLib}::Gui
        PRIVATE machine os_emulation assembler svgscene)
target_compile_definitions(gui
        PRIVATE
        APP_ORGANIZATION=\"${MAIN_PROJECT_ORGANIZATION}\"
        APP_ORGANIZATION_DOMAIN=\"${MAIN_PROJECT_HOMEPAGE_URL}\"
        APP_GIT=\"${MAIN_PROJECT_HOMEPAGE_URL}\"
        APP_NAME=\"${MAIN_PROJECT_NAME}\"
        APP_VERSION=\"${MAIN_PROJECT_VERSION}\"
        ENV_CONFIG_FILE_NAME=\"${MAIN_PROJECT_NAME_UPPER}_CONFIG_FILE\")
set_target_properties(gui PROPERTIES
        OUTPUT_NAME "${MAIN_PROJECT_NAME_LOWER}_${PROJECT_NAME}")

if (${${QtLib}PrintSupport_FOUND} AND NOT ${WASM})
    target_link_libraries(gui PRIVATE ${QtLib}::PrintSupport)
    target_compile_definitions(gui PRIVATE WITH_PRINTING=1)
endif ()

# MACOS
set_property(SOURCE ${ICON_PATH}
        PROPERTY MACOSX_PACKAGE_LOCATION Resources)
set_target_properties(gui PROPERTIES
        MACOSX_BUNDLE true
        MACOSX_BUNDLE_GUI_IDENTIFIER cz.cvut.fel.${MAIN_PROJECT_ORGANIZATION}.gui
        MACOSX_BUNDLE_BUNDLE_NAME ${MAIN_PROJECT_NAME}
        MACOSX_BUNDLE_BUNDLE_VERSION "${MAIN_PROJECT_VERSION}"
        MACOSX_BUNDLE_SHORT_VERSION_STRING "${MAIN_PROJECT_VERSION}"
        MACOSX_BUNDLE_ICONFILE ${ICON_NAME}
        )
# END MACOS

# =============================================================================
# Installation
# =============================================================================

# Prior to CMake version 3.13, installation must be performed in the subdirectory,
# there the target was created. Therefore executable installation is to be found
# in corresponding CMakeLists.txt.

install(TARGETS gui
        RUNTIME DESTINATION bin
        BUNDLE DESTINATION ${EXECUTABLE_OUTPUT_PATH}
        )

=== src/machine/CMakeLists.txt ===
project(machine
		DESCRIPTION "The actual simulator as a library. Link with an UI of your choice.")

set(CMAKE_AUTOMOC ON)

set(machine_SOURCES
		execute/alu.cpp
		csr/controlstate.cpp
		core.cpp
		instruction.cpp
		machine.cpp
		machineconfig.cpp
		memory/backend/lcddisplay.cpp
		memory/backend/memory.cpp
		memory/backend/peripheral.cpp
		memory/backend/peripspiled.cpp
		memory/backend/serialport.cpp
		memory/backend/aclintmtimer.cpp
		memory/backend/aclintmswi.cpp
		memory/backend/aclintsswi.cpp
		memory/cache/cache.cpp
		memory/cache/cache_policy.cpp
		memory/frontend_memory.cpp
		memory/memory_bus.cpp
		programloader.cpp
		predictor.cpp
		registers.cpp
		simulator_exception.cpp
		symboltable.cpp
		)

set(machine_HEADERS
		execute/alu.h
		csr/controlstate.h
		core.h
		core/core_state.h
		csr/address.h
		instruction.h
		machine.h
		machineconfig.h
		config_isa.h
		machinedefs.h
		memory/address.h
		memory/address_range.h
		memory/backend/backend_memory.h
		memory/backend/lcddisplay.h
		memory/backend/memory.h
		memory/backend/peripheral.h
		memory/backend/peripspiled.h
		memory/backend/serialport.h
		memory/backend/aclintmtimer.h
		memory/backend/aclintmswi.h
		memory/backend/aclintsswi.h
		memory/cache/cache.h
		memory/cache/cache_policy.h
		memory/cache/cache_types.h
		memory/frontend_memory.h
		memory/memory_bus.h
		memory/memory_utils.h
		programloader.h
		predictor_types.h
		predictor.h
		pipeline.h
		registers.h
		register_value.h
		simulator_exception.h
		symboltable.h
		utils.h
		execute/alu_op.h
		execute/mul_op.h
		)

# Object library is preferred, because the library archive is never really
# needed. This option skips the archive creation and links directly .o files.
add_library(machine STATIC
		${machine_SOURCES}
		${machine_HEADERS})
target_link_libraries(machine
		PRIVATE ${QtLib}::Core
		PUBLIC libelf)

if(NOT ${WASM})
	# Machine tests (not available on WASM)

	add_executable(alu_test
			execute/alu.test.cpp
			execute/alu.test.h
			execute/alu.cpp
			execute/alu.h
			)
	target_link_libraries(alu_test
			PRIVATE ${QtLib}::Core ${QtLib}::Test)
	add_test(NAME alu COMMAND alu_test)

	add_executable(registers_test
			register_value.h
			registers.cpp
			registers.h
			registers.test.cpp
			registers.test.h
			simulator_exception.cpp
			simulator_exception.h
			)
	target_link_libraries(registers_test
			PRIVATE ${QtLib}::Core ${QtLib}::Test)
	add_test(NAME registers COMMAND registers_test)

	add_executable(memory_test
			memory/backend/backend_memory.h
			memory/backend/memory.cpp
			memory/backend/memory.h
			memory/backend/memory.test.cpp
			memory/backend/memory.test.h
			memory/frontend_memory.cpp
			memory/frontend_memory.h
			memory/memory_bus.cpp
			memory/memory_bus.h
			simulator_exception.cpp
			simulator_exception.h
			tests/utils/integer_decomposition.h
			)
	target_link_libraries(memory_test
			PRIVATE ${QtLib}::Core ${QtLib}::Test)
	add_test(NAME memory COMMAND memory_test)

	add_executable(cache_test
			machineconfig.cpp
			machineconfig.h
			config_isa.h
			memory/backend/backend_memory.h
			memory/backend/memory.cpp
			memory/backend/memory.h
			memory/cache/cache.cpp
			memory/cache/cache.h
			memory/cache/cache.test.cpp
			memory/cache/cache.test.h
			memory/cache/cache_policy.cpp
			memory/cache/cache_policy.h
			memory/frontend_memory.cpp
			memory/frontend_memory.h
			memory/memory_bus.cpp
			memory/memory_bus.h
			simulator_exception.cpp
			simulator_exception.h
			tests/data/cache_test_performance_data.h
			tests/utils/integer_decomposition.h
			)
	target_link_libraries(cache_test
			PRIVATE ${QtLib}::Core ${QtLib}::Test)
	add_test(NAME cache COMMAND cache_test)

	add_executable(instruction_test
			csr/controlstate.cpp
			csr/controlstate.h
			instruction.cpp
			instruction.h
			instruction.test.cpp
			instruction.test.h
			simulator_exception.cpp
			simulator_exception.h
			)
	target_link_libraries(instruction_test
			PRIVATE ${QtLib}::Core ${QtLib}::Test)
	add_test(NAME instruction COMMAND instruction_test)

	add_executable(program_loader_test
			csr/controlstate.cpp
			csr/controlstate.h
			instruction.cpp
			instruction.h
			memory/backend/backend_memory.h
			memory/backend/memory.cpp
			memory/backend/memory.h
			programloader.cpp
			programloader.h
			programloader.test.cpp
			programloader.test.h
			simulator_exception.cpp
			simulator_exception.h
			symboltable.cpp
			symboltable.h
			)
	target_link_libraries(program_loader_test
			PRIVATE ${QtLib}::Core ${QtLib}::Test libelf)
	add_test(NAME program_loader COMMAND program_loader_test)


	add_executable(core_test
			csr/controlstate.cpp
			csr/controlstate.h
			core.cpp
			core.h
			core.test.cpp
			core.test.h
			execute/alu.cpp
			execute/alu.h
			instruction.cpp
			instruction.h
			memory/backend/backend_memory.h
			memory/backend/memory.cpp
			memory/backend/memory.h
			memory/cache/cache.cpp
			memory/cache/cache.h
			memory/cache/cache_policy.cpp
			memory/cache/cache_policy.h
			memory/frontend_memory.cpp
			memory/frontend_memory.h
			memory/memory_bus.cpp
			memory/memory_bus.h
			registers.cpp
			registers.h
			predictor.cpp
			predictor.h
			predictor_types.h
			simulator_exception.cpp
			simulator_exception.h
			machineconfig.cpp
			)
	target_link_libraries(core_test
			PRIVATE ${QtLib}::Core ${QtLib}::Test libelf)
	add_test(NAME core COMMAND core_test)

	add_custom_target(machine_unit_tests
			DEPENDS alu_test registers_test memory_test cache_test instruction_test program_loader_test core_test)
endif()

=== src/common/polyfills/CMakeLists.txt ===
project(polyfills
		DESCRIPTION "Helper code to unify access to compiler intrinsics and
                     provide fallback implementations.")

set(polyfills_HEADERS
		endian_detection.h
		mulh64.h
		clz32.h
		byteswap.h
		qstring_hash.h
		qt5/qfontmetrics.h
		qt5/qlinef.h
		qt5/qtableview.h
		)

# =============================================================================
# Target for usage of this header library
# - this is header only library and it is implicitly available in the whole
#   project
# =============================================================================

# =============================================================================
# Tests
# - It is highly recommended to run these tests anytime you use a different
#   compiler or platform as this code is platform/compiler specific.
# =============================================================================

if(NOT "${WASM}")
	set(CMAKE_AUTOMOC ON)

	add_executable(mulh64_test
			mulh64.h
			mulh64.test.h
			mulh64.test.cpp
			)
	target_link_libraries(mulh64_test PRIVATE ${QtLib}::Test)
	add_test(NAME mulh64
			COMMAND mulh64_test)
endif()

=== tests/riscv-official/isa/Makefile ===
#=======================================================================
# Makefile for riscv-tests/isa
#-----------------------------------------------------------------------

XLEN ?= 64

src_dir := .

isa_dir := ../riscv-tests/isa

ifeq ($(XLEN),64)
include $(isa_dir)/rv64ui/Makefrag
include $(isa_dir)/rv64ua/Makefrag
include $(isa_dir)/rv64si/Makefrag
include $(isa_dir)/rv64mi/Makefrag
include $(isa_dir)/rv64um/Makefrag
endif
include $(isa_dir)/rv32ui/Makefrag
include $(isa_dir)/rv32ua/Makefrag
include $(isa_dir)/rv32si/Makefrag
include $(isa_dir)/rv32mi/Makefrag
include $(isa_dir)/rv32um/Makefrag

default: clean all

#--------------------------------------------------------------------
# Build rules
#--------------------------------------------------------------------

include toolchain_setup

vpath %.S $(isa_dir) $(self_test)

#------------------------------------------------------------
# Build assembly tests

%.dump: %
	$(RISCV_OBJDUMP) elf/$< > dump/$@

%.out: %
	$(RISCV_SIM) --isa=rv64gc $< 2> $@

%.out32: %
	$(RISCV_SIM) --isa=rv32gc $< 2> $@

define compile_template



$$($(1)_p_tests): $(1)-p-%: $(1)/%.S
	$$(RISCV_COMPILER) $(2) $$(RISCV_COMPILER_OPTS) -I$(src_dir)/../env/p -I$(isa_dir)/macros/scalar -T$(src_dir)/../env/p/link.ld $$< -o elf/$$@
$(1)_tests += $$($(1)_p_tests)

$(1)_tests_dump = $$(addsuffix .dump, $$($(1)_tests))

$(1): $$($(1)_tests_dump)

.PHONY: $(1)

COMPILER_SUPPORTS_$(1) := $$(shell $$(RISCV_COMPILER) $(2) -c -x c /dev/null -o /dev/null 2> /dev/null; echo $$$$?)

ifeq ($$(COMPILER_SUPPORTS_$(1)),0)
tests += $$($(1)_tests)
endif

endef
$(eval $(call compile_template,rv32ui, $(MARCH_OPTS_32)))
$(eval $(call compile_template,rv32um, $(MARCH_OPTS_32)))
$(eval $(call compile_template,rv32ua, $(MARCH_OPTS_32)))
$(eval $(call compile_template,rv32si, $(MARCH_OPTS_32)))
$(eval $(call compile_template,rv32mi, $(MARCH_OPTS_32)))
ifeq ($(XLEN),64)
$(eval $(call compile_template,rv64ui, $(MARCH_OPTS_64)))
$(eval $(call compile_template,rv64um, $(MARCH_OPTS_64)))
$(eval $(call compile_template,rv64ua, $(MARCH_OPTS_64)))
$(eval $(call compile_template,rv64si, $(MARCH_OPTS_64)))
$(eval $(call compile_template,rv64mi, $(MARCH_OPTS_64)))
endif

tests_dump = $(addsuffix .dump, $(tests))
tests_hex = $(addsuffix .hex, $(tests))
tests_out = $(addsuffix .out, $(filter rv64%,$(tests)))
tests32_out = $(addsuffix .out32, $(filter rv32%,$(tests)))

run: $(tests_out) $(tests32_out)

junk += $(tests) $(tests_dump) $(tests_hex) $(tests_out) $(tests32_out)

#------------------------------------------------------------

self-tests:
	cd selftests && make

all: $(tests_dump) self-tests

#------------------------------------------------------------
# Clean up

clean:
	rm -rf $(junk)
	rm -fr elf/*
	rm -fr dump/*
	rm -fr $(self_test)/elf/*

=== tests/riscv-official/isa/selftests/Makefile ===
#=======================================================================
# Makefile for riscv-tests/isa
#-----------------------------------------------------------------------

XLEN ?= 64

src_dir := ../.

isa_dir := ../../riscv-tests/isa

self_test := .
self_tests_t := $(wildcard tests/*.S)
self_tests := $(self_tests_t:tests/%=%)
elf_tests := $(self_tests:.S=.elf)

default: clean self

#--------------------------------------------------------------------
# Build rules
#--------------------------------------------------------------------

include ../toolchain_setup

vpath %.S $(self_test)

#------------------------------------------------------------
# Build assembly tests

self: $(elf_tests)

%32.elf: tests/%32.S
	$(RISCV_COMPILER) $(MARCH_OPTS_32) $(RISCV_COMPILER_OPTS) -I$(src_dir)/../env/p -I$(isa_dir)/macros/scalar -T$(src_dir)/../env/p/link.ld $< -o $(self_test)/elf/$*32

%64.elf: tests/%64.S
	$(RISCV_COMPILER) $(MARCH_OPTS_64) $(RISCV_COMPILER_OPTS) -I$(src_dir)/../env/p -I$(isa_dir)/macros/scalar -T$(src_dir)/../env/p/link.ld $< -o $(self_test)/elf/$*64
#------------------------------------------------------------
# Clean up

clean:
	rm -fr elf/*

=== debian/changelog ===
qtrvsim (0.9.8-1) unstable; urgency=medium

  * Add gbp.conf
  * New upstream version 0.9.8
  * Drop adding-keywords.patch which appiled by upstream
  * Add 00-fix-spell.patch
  * Update qtrvsim_cli.1

 -- Bo YU <vimer@debian.org>  Wed, 12 Feb 2025 09:24:06 +0800

qtrvsim (0.9.7-1) unstable; urgency=low

  * Initial release. Closes: (Closes: #1068899)

 -- Bo YU <tsu.yubo@gmail.com>  Mon, 23 Sep 2024 16:50:05 +0800

=== debian/control ===
Source: qtrvsim
Section: devel
Priority: optional
Maintainer: Bo YU <vimer@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 qtbase5-dev,
 libelf-dev,
 help2man,
Standards-Version: 4.7.0
Homepage: https://github.com/cvut/qtrvsim
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/vimerbf-guest/qtrvsim.git
Vcs-Browser: https://salsa.debian.org/vimerbf-guest/qtrvsim

Package: qtrvsim
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: RISC-V CPU simulator for education
 RISC-V CPU simulator for education purposes with pipeline and cache
 visualization.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export QT_SELECT := qt5

include /usr/share/dpkg/pkg-info.mk
export DEB_VERSION_UPSTREAM

mandir := $(CURDIR)/debian/qtrvsim/usr/share/man/man1

%:
	dh $@ --buildsystem cmake

override_dh_auto_install:
	dh_auto_install
	mkdir -p $(mandir)
ifeq ($(DEB_HOST_GNU_TYPE), $(DEB_BUILD_GNU_TYPE))
	help2man $(CURDIR)/debian/qtrvsim/usr/bin/qtrvsim_cli --name="RISC-V CPU simulator for education" --version-string=$(DEB_VERSION_UPSTREAM) > $(mandir)/qtrvsim_cli.1
else
	install -m 644 $(CURDIR)/debian/manpage/qtrvsim_cli.1 $(mandir)
endif

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	ctest --test-dir $(CURDIR)/obj-$(DEB_HOST_GNU_TYPE);
endif

=== debian/tests/control ===
#
# DEP-8: autopkgtest - automatic as-installed package testing
#        Please check * https://dep-team.pages.debian.net/deps/dep8/
#                     * /usr/share/doc/autopkgtest
#
# !!! Please make sure to edit this to a valid test, otherwise build will fails
#
#Tests: testcode.sh
#Restrictions: allow-stderr, breaks-testbed, needs-internet, needs-root

Tests: test
Depends: @,  gcc-riscv64-unknown-elf 
Restrictions: allow-stderr, needs-root

=== debian/watch ===
version=4
https://github.com/cvut/qtrvsim/tags .*/v?@ANY_VERSION@\.tar\.gz
